unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, iSlidingScale, iComponent, iVCLComponent, iCustomComponent,
  iPositionComponent, iScaleComponent, iGaugeComponent, iLinearGauge, ExtCtrls,
  StdCtrls, CPort, CPortCtl;

type
  TForm2 = class(TForm)
    iLinearGaugeX: TiLinearGauge;
    iLinearGaugeY: TiLinearGauge;
    ComPort1: TComPort;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    ComDataPacket1: TComDataPacket;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComDataPacket1Packet(Sender: TObject; const Str: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
    ComPort1.ShowSetupDialog;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if NOT ComPort1.Connected then
    begin
      ComPort1.Open;
      Button2.Caption:='Disconnect';
      Memo1.Lines.Add('Connect.....')
    end
  else
    begin
      ComPort1.Close;
      Button2.Caption:='Connect';
      Memo1.Lines.Add('Disconnected')
    end
end;

procedure TForm2.ComDataPacket1Packet(Sender: TObject; const Str: string);
var
  i:integer;
  s:string;
  Roll,Pitch,Yaw:SmallInt;
  tmp:single;
begin
  s:=' [';
  for i := 1 to length(Str) do
    s:=s+' '+IntToHex(ord(Str[i]),2);
  s:=s+']';
  Memo1.Lines.Add(s);

  Roll:=(Ord(Str[2]) shl 8 + Ord(Str[1]));
  tmp:= Roll * 180 /32768;
  iLinearGaugeX.Position:=tmp;
  s:=FormatFloat('00.00',tmp)+'   ';

  Pitch:=(Ord(Str[4]) shl 8 + Ord(Str[3]));
  tmp:=Pitch * 180 /32768;
  iLinearGaugeY.Position:=tmp;
  s:=s+FormatFloat('00.00',tmp)+'  ';

  Yaw:=(Ord(Str[6]) shl 8 + Ord(Str[5]));
  tmp:=Yaw *180 /32768;
  s:=s+FormatFloat('00.00',tmp);

  Memo1.Lines.Add(s);


end;

end.
